c     FORTRAN77 code
c     File: foretv.for
c
c     This program is intended for nonlinear error correction models
c     It provides measures of forecasting power of TVECM models
c     
c     Created by Antoni Vidiella to analyze interest rates
c
c     Parameters of the model must be given
c
c     input:  dat(.,.) is the data matrix 2 columns of data
ccccc Current setting
c
c     Number-variables = 2
c     max-ar-p = 29
c     max-obs  = 500
c     maximum number of regimes = 5
c
ccccc Definition of variables
c
      implicit real*8 (a-h,o-z)
      integer seed
      parameter(nmax=500,ipmax=3,ithmax=5)
      dimension dat(nmax,ipmax),x46(ipmax,1),x42(ipmax,1),var(ipmax)
      dimension x45(ipmax,1),predm(ipmax),h(ipmax,ipmax),d(ipmax,ipmax)
      dimension thr(ithmax),rnn(ipmax),pred(ipmax),x44(ipmax,1)
      dimension dreg(2,2*ipmax,2),cep(ipmax),rlop(ipmax),ri(200)
      dimension hreg(ipmax,ipmax,2),cov(ipmax,ipmax,2),x43(ipmax,1)
      dimension cov1(ipmax,ipmax),x39(ipmax,1),x40(ipmax,1),x41(ipmax,1)
c
      character nfile*30,nres*30
      external zeromat,addmat,multmat,zerovec,chlsk,gnorm
c
      open (10,file='tvecm.res',status='unknown')
c
ccccc Introduction of data
c
      seed=1234567890
      write(6,1)
      write(6,2)
      write(6,3)
      write(6,4)
      write(6,5)
      write(6,501)
 1    format(1x,'Please choose the model to forecast: ')
 2    format(1x,'1. DVAR ')
 3    format(1x,'2. VECM ')
 4    format(1x,'3. MTAR ')
 5    format(1x,'4. TVECM ')
      read(5,*) kind
      nreg=2
      if (kind.eq.1.or.kind.eq.2) nreg=1
      write(6,6)
      int=0
      read(5,*) int
 6    format(1x,'Does the model have intercept? (yes=1,no=0): ')
      npam=2+int
      if (kind.eq.1.or.kind.eq.3) npam=4+int
      do 11 i=1,nreg
         if (nreg.gt.1) write(6,8) i
         do 10 j=1,2
               write (6,501)
               write (6,9) j,npam
 10            read(5,*) (dreg(j,k,i),k=1,npam)
               if (kind.eq.2.or.kind.eq.4) then
                  write(6,501)
                  write(6,14)
                  cep(1)=1.0
                  read(5,*) (cep(k),k=2,3)
                  write(6,501)
                  write(6,15)
                  read(5,*) (rlop(k),k=1,2)
                  ib=0
                  if(cep(3).gt.0.0) ib=1
                  do 18 k1=1,2
                     do 18 k2=1,2+ib
 18                     hreg(k1,k2,i)=rlop(k1)*cep(k2)
                  npamh=2+ib
               endif
               write(6,501)
               write(6,16)
               do 20 k1=1,2
 20               read(5,*) (cov(k1,k2,i),k2=1,2)
 11   continue 
 8    format(1x,'Parameters of regime:',i3,' 1=lower, 2 upper')
 9    format(1x,'Input parameters of equation:',i3,' ; ',i3,'
     1parameters are required')
 14   format(1x,'Input parameters of CE (if no intercept 2nd=0.0)')
 15   format(1x,'Input parameters of loading vector')
 16   format(1x,'Input parameters of covariance matrix')
c
      id=1
      write(6,19)
 19   format(1x,'Data File Name : ')
      read (5,93) nfile
 93   format(a30)
      nob=0
      open(9,file=nfile,status='old')
      read(9,*) nob
      do 17 i=1,nob
 17      read(9,*) (dat(i,j),j=1,2)
      close(9)
      write(6,100)
      write(6,101)
      write(6,103)
      write(6,104)
      write(6,501)

 100  format(1x,'Please choose the forecasting method: ')
 101  format(1x,'1. Skeleton ')
 103  format(1x,'2. Monte Carlo ')
 104  format(1x,'3. Bootstrapping ')
 501  format(' ')
      read(5,*) ifor
c      if (ifor.eq.3) then
c         write(6,105)
c         read(5,3) nres
c         open(10,file=nres,status='old')
c         do 110 i=1,nreg
c            read(10,*) nr(i)
c            do 110 j=1,nr(i)
c 110           read(10,*) (res(j,k,i),k=1,2)
c         close(10)
c      endif
c 105  format(1x,' Residuals File Name : ')
 107  continue
      write (6,106)
      ist=2
 106  format(1x,'Input forecasting period 1st & nend : ')
      read(5,*) ist, nend
      if (nend.gt.nob) then
         write(6,*) 'Out of sample ! input another forescating date'
         goto 107
      endif
c        if(nend.gt.nob) nend=nob
c        if(ist.lt.1) ist = 1
c        nob = nend-ist+1
c        if(ist.eq.1)go to 30
c        do 20 it=1, nob   
c           do 20 i=1, 2
c 20           dat(it,i) = dat(it-1+ist,i)
c 30   continue      
c--------- input thresholds
      if (kind.eq.3.or.kind.eq.4) then
	     write(6,50)
	     read(5,*) b1
      endif
c      nob=nob-1
 50   format(1x,'Enter parameter of cointegration (1, x): ')
      ip=2
      write(6,40) 
      read(5,*) thr(2)      
      thr(1) = -9.9d+10
      thr(3) = 9.9d+10
 40   format(1x,'input threshold: ')
c     inici del proces de forescasting
c     istep  # de step ahead of forecasting
c el problema es que no puc anar acumulant prediccions per al no-lineal,
c s'han d'anar calculant separadament fins a cada h-step
      do 43 i=1,2
 43      x39(i,1)=dat(nend,i)-dat(nend-1,i)
      istep=nend-ist
      if(ifor.eq.1) then
         call zerovec(var,ipmax,ipmax)
         do 800 ix=1,istep
            do 46 j=1,2
              x40(j,1)=dat(ist+ix-1,j)-dat(ist+ix-2,j)
              x41(j,1)=dat(ist+ix-1,j) 
 46           err=dat(ist+ix-1,1)-b1*dat(ist+ix-1,2)
              ia=1
              if(err.ge.thr(2)) ia=2
c     x40 inclou el vector de ultimes variacions
              do 150 i=1,2
                 do 150 j=1,npam
 150             d(i,j)=dreg(i,j,ia)
              if(kind.eq.2.or.kind.eq.4) then
                 do 160 i=1,2
                    do 160 j=1,npamh
 160                   h(i,j)=hreg(i,j,ia)
              endif
c    forecasting computing
              call multmat(d,x40,x42,2,ipmax,2,npam,1)
              call multmat(h,x41,x43,ipmax,ipmax,2,npamh,1)
              call addmat(x42,x43,x45,ipmax,2,1,-1)
c    x45 inclou les prediccions per les dues variables
c    x46 inclou els errors de prediccio per les dues variables
              do 170 j=1,2                 
                 dat(ist+ix,j)=dat(ist+ix-1,j)+x45(j,1)
 170             write(6,*) dat(ist+ix,j)
 800   continue
              call addmat(x39,x45,x46,ipmax,2,1,-1)
c aixi he variat dat i calcula l'eskeleton de manera succesiva
               goto 200
      else if(ifor.eq.2) then
         do 190 i=1,2
            do 195 j=1,2
               do 195 k=1,2
 195              cov1(j,k)=cov(j,k,i)
                  call chlsk(ipmax,2,cov1,nrang,det,kode)
            do 181 j=1,2
               do 181 k=1,2
 181              cov(j,k,i)=cov1(j,k)
 190     continue
c a cov hi ha la descomposici de cholesky de la matriu de covariancies
c ara haig de generar dos nombres aleatoris normals i independents.
c a ij hi ha el nombre de periodes a simular
c valor a predir   x39(j,1)=dat(ist+ix,j)-dat(ist+ix-1,j)
         isim=10
         do 198 iq=1,isim
            do 192 ik=1,istep
               do 194 j=1,2
                  if (ik.gt.1) dat(ist+ik-1,j)=dat(ist+ik-2,j)+var(j)    
                  x40(j,1)=dat(ist+ik-1,j)-dat(ist+ik-2,j)
                  x41(j,1)=dat(ist+ik-1,j) 
 194              err=dat(ist+ik-1,1)-b1*dat(ist+ik-1,2)
               ia=1
               if(err.ge.thr(2)) ia=2
               CALL ZEROVEC(RI,100,100)
               CALL GNORM(RI,100,SEED)
c agafo com a nombres aleatoris el 50 i el 100
c i calculo les innovacions correlacionades emprant el resultat de cholesky            
               rnn(1)=ri(50)*cov(1,1,ia)
               rnn(2)=ri(50)*cov(2,1,ia)+ri(100)*cov(2,2,ia)   
              do 151 i=1,2
                 do 151 j=1,npam
 151             d(i,j)=dreg(i,j,ia)
              if(kind.eq.2.or.kind.eq.4) then
                 do 161 i=1,2
                    do 161 j=1,npamh
 161                   h(i,j)=hreg(i,j,ia)
               endif
               call multmat(d,x40,x42,2,ipmax,2,npam,1)
               call multmat(h,x41,x43,ipmax,ipmax,2,npamh,1)
               call addmat(x42,x43,x44,ipmax,2,1,-1)
               do 171 j=1,2
 171              var(j)=x45(j,1)+rnn(j)
               call zeromat(x40,ipmax,ipmax,1)
               call zeromat(x41,ipmax,ipmax,1)
               call zeromat(x42,ipmax,ipmax,1)
               call zeromat(x43,ipmax,ipmax,1)
               call zeromat(x44,ipmax,ipmax,1)
               call zerovec(rnn,ipmax,ipmax)
 192        continue
c    ara a var i dat(ist+ik-2) hi ha els valors estimats VAR, ara s'ha
c    de fer la mitjana
            do 199 i=1,2
               write(6,*) var(i), i
 199           pred(i)=pred(i)+var(i)
 198     continue
            do 205 i=1,2
 205           predm(i)=pred(i)/real(isim)
        write(6,*) (predm(i),i=1,2)
        endif
 200    continue
        write(6,*) 
c         else if(ifor.eq.3) then
c            do 194 ik=1,ij
c               ipos=int(randu(seed)*nr(ia))
c               do 194 i=1,2
c 194              rnn(ik,i)=res(ipos,i,ia)
      end       

      SUBROUTINE MULTMAT(AMAT,BMAT,CMAT,ID1MAX,ID2MAX,L1,L2,L3)
C**********************************************************************
C     PORPOSE: MATRIX MULTIPLICATION
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C            BMAT, MATRIX DIMENSION L2,L3
C     OUPUT: CMAT, MATRIX DIMENSION L1,L3
C**********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID2MAX,*),CMAT(ID1MAX,*)
      DO 99 J=1,L3
	 DO 98 K=1,L2
	    IF (BMAT(K,J).EQ.0.0) GOTO 98
	    DO 97 I=1,L1
	       CMAT(I,J)=CMAT(I,J)+AMAT(I,K)*BMAT(K,J)
   97       CONTINUE
   98    CONTINUE
   99 CONTINUE
      RETURN
      END
     
      SUBROUTINE ZEROMAT(AMAT,ID1MAX,L1,L2)
C**************************************************************
C     PORPOSE: CREATE A MATRIX OF ZEROS
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C     OUTPUT: AMAT, ZEROED MATRIX DIMENSION L1,L2
C**************************************************************
      
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*)
      DO 98 J=1,L2
	 DO 99 I=1,L1
	    AMAT(I,J)=0.0
  99     CONTINUE
  98  CONTINUE
      RETURN
      END

      SUBROUTINE ZEROVEC(VEC,ID1MAX,L1)
C**************************************************************
C     PORPOSE: CREATE A VECTOR OF ZEROS      
C     INPUT: VEC, VECTOR DIMENSION L1
C     OUTPUT: VEC, ZEROED VECTOR DIMENSION L1
C**************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION VEC(ID1MAX)

      DO 98 I=1,L1     
		VEC(I)=0.0
  98  CONTINUE
      RETURN
	END
   
      SUBROUTINE EQMAT(AMAT,BMAT,ID1MAX,ID2MAX,L1,L2)
C**************************************************************
C     PORPOSE: EQUALIZATION OF MATRICES 
C     INPUT: AMAT, MATRIX DIMENSION L1 L2
C     OUPUT: BMAT, MATRIX EQUAL AMAT DIMENSION L1 L2
C**************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID2MAX,*)
C
      DO 98 J=1,L2
	 DO 99 I=1,L1
	    BMAT(I,J)=AMAT(I,J)
   99    CONTINUE
   98 CONTINUE
      RETURN
      END

      SUBROUTINE EQVEC(VECA,VECB,ID1MAX,L1)
C******************************************************************
C     PORPOSE: EQUALIZATION OF VECTORS
C     INPUT: VECA, VECTOR DIMENSION L1
C     OUTPUT: VECB, VECTOR EQUAL VECA DIMENSON L1
C******************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION VECA(ID1MAX),VECB(ID1MAX)
C
      DO 99 I=1,L1
	    VECB(I)=VECA(I)
   99 CONTINUE
      RETURN
      END

      SUBROUTINE ADDMAT(AMAT,BMAT,CMAT,ID1MAX,L1,L2,IND)
C**********************************************************************
C     PORPOSE: MATRIX SUM
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C            BMAT, MATRIX DIMENSION L1,L2
C            IND,  INDICATOR VARIABLE: 1, ADD
C                                     -1, EXTRACT
C     OUPUT: CMAT, MATRIX DIMENSION L1,L2
C**********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID1MAX,*),CMAT(ID1MAX,*)
      EXTERNAL ZEROMAT
      CALL ZEROMAT(CMAT,ID1MAX,L1,L3)
      DO 2 J=1,L1
	 DO 2 K=1,L2
 2          CMAT(J,K)=AMAT(J,K)+IND*BMAT(J,K)
      RETURN
      END


C*********************************CHLSK******************************
      SUBROUTINE CHLSK (NDIM,N,W,NRANG,DET,KODE)
C********************************************************************
C  DESCOMPOSICION DE CHOLESKY DE LA MATRIZ SIMETRICA SEMIDEFINIDA 
C  POSITIVA W(N,N). NDIM=DIMENSION RESERVADA PARA W(NDIM,NDIM)
C
C  SALIDAS:
C    W(,) MATRIZ TRIANGULAR INFERIOR TAL QUE W*WPRIM=MATRIZ INICIAL
C    NRANG RANGO DE W (SI NRANG.LT.N SE PONE A 0 LAS FILAS EN CUESTION
C    DET DETERMINANTE DE W
C    KODE=1 SI W NO FUESE SEMIDEF. POSITIVA, SINO KODE=0
C*********************************************************************
        implicit real*8 (a-h,o-z)
        DIMENSION W(NDIM,n)
        DATA EPS / 1.0d-4 /
        KODE=0
        NRANG=N
        DET=1.0
          DO 70 I=1,N 
          DO 40 J=1,I
        V=W(I,J)
          DO 10 L=1,J
          IF (L.EQ.J)            GO TO 20
10      V=V-W(I,L)*W(J,L)
20        CONTINUE
          IF (I .EQ. J)          GO TO 50
        W(J,I)=0.0
          IF (W(J,L).EQ.0.0)     GO TO 30
        W(I,J)=V/W(J,L)
                                 GO TO 40
30      W(J,I)=0.0
40        CONTINUE
50      EPSIL=ABS(EPS*W(I,J))
          IF (ABS(V).LE.EPSIL)   GO TO 60
          IF (V.LT.0.0)          GO TO 80
        DET=DET*V
        W(I,J)=SQRT(V)
                                 GO TO 70
60      W(I,J)=0.0
        DET=0.0
        NRANG=NRANG-1
70      CONTINUE
         RETURN
80      KODE=1
         RETURN
         END

       subroutine gnorm(r,nr,rs)
C       IMPLICIT REAL (A-H,O-Z)
       integer nr,rs
       real*8 r(*)
       do  1 i=1,nr
99        continue         
          v=randu(rs)*2.-1.
          u=randu(rs)*2.-1.
          w=v*v+u*u
          if(w.gt.1)goto 99
          c=sqrt(-2.*alog(w)/w)
          R(i)=c*v
          r(i+1)=c*u
1      continue
       return
       end                      
	   	   
C**************************************************************************  
C  
      REAL FUNCTION RANDU(IX)  
C  
C UNIFORM RANDOM NUMBER GENERATOR.  
C REF: SCHRAGE, L. 1979 'A MORE PORTABLE FORTRAN RANDOM NUMBER GENERATOR'  
C      A. C. M. TRANSACTIONS ON MATHEMATICAL SOFTWARE V5 132-138.  
C  
      INTEGER A,P,IX,B15,B16,XHI,XALO,LEFTLO,FHI,K  
      DATA A/16807/,B15/32768/,B16/65536/,P/2147483647/  
      XHI=IX/B16  
      XALO=(IX-XHI*B16)*A  
      LEFTLO=XALO/B16  
      FHI=XHI*A+LEFTLO  
      K=FHI/B15  
      IX=(((XALO-LEFTLO*B16)-P)+(FHI-K*B15)*B16)+K  
      IF (IX.LT.0) IX=IX+P  
      RANDU=FLOAT(IX)*4.656612875E-10  
      RETURN  
      END  
C
