c     FORTRAN77 code    
c     File: simtecm.for
c
c     This program is intended for nonlinear error correction models
c     It checks the estimation power of the 2SLS method for TVECM
c     Created by Antoni Vidiella and modified by JDG
cc
c
ccccc Current setting
c
c     Number-variables = 2
c     max-ar-p = 29
c     max-obs  = 500
c     maximum number of regimes = 5
c
ccccc Definition of variables
c
      implicit real*8 (a-h,o-z)
      parameter(nmax=100,mk=3,ipmax=3,kmax=20,ithmax=5)
      dimension dat(nmax,ipmax),er(ipmax,ipmax),rnn(ipmax)
      dimension dat2(nmax,ipmax),dat3(nmax,ipmax),dat4(nmax,ipmax)
      dimension npts(mk),y1(ipmax,nmax),x1(ipmax,nmax),x2(nmax,ipmax)
      dimension x3(ipmax,ipmax),x4(ipmax,ipmax),x5(ipmax,nmax)
      dimension x6(nmax,nmax),x9(nmax,1),x13(ipmax,1),x17(1,nmax)
      dimension x7(nmax,nmax),x8(ipmax,nmax),coef2(ipmax,1)
      dimension x10(nmax,1),x11(ipmax,1),x12(ipmax,nmax)
      dimension x14(1,ipmax),x15(1,1),h(ipmax,1),x16(nmax,ipmax)
      dimension x18(ipmax,nmax),x19(ipmax,nmax),d(ipmax,ipmax)
      dimension elp1(ipmax,ipmax),hreg(ipmax,ipmax,2)
      dimension x30(ipmax,nmax),x31(ipmax,nmax),bcan(1000)
      dimension x32(ipmax,nmax),x33(nmax,ipmax),x34(ipmax,kmax)
      dimension thr(ithmax),xm(nmax,nmax),post(nmax),beta(nmax,2)
      dimension wk(ipmax,ipmax),c1(ipmax),c2(ipmax),desv1(ipmax)
      dimension desv2(ipmax),det1(nmax),param(10000,5)
      dimension ri(100),x41(ipmax,1),var(ipmax)
      dimension x43(ipmax,1),dat5(1000+nmax,ipmax)
      dimension err1(nmax),h1(ipmax,ipmax)
c
      integer seed
      external zeromat,addmat,matinv,trnmat,multmat
      external reg,pcand,zerovec,gnorm
c
c
ccccc Introduction of data
c
      open (10,file='simtv.res',status='unknown')
      seed=123456789
      irun=1000
      nob1=100
      id=1
      nreg=2
      ierr=1
      ict=0
      pl=0.15
      pu=0.85
      if (ierr.eq.0) then
	   write(6,50)
	   read(5,*) b1
      else
	 sig=10.0
	 iprec=2
      end if
 50   format(1x,'Enter parameter of cointegration (1, x): ')
      b1=1.0
      npam=2
      npamh=2
      call zeromat(d,ipmax,ipmax,ipmax)
      do 153 ia=1,2
	 do 153 i=1,2
	    do 153 j=1,2
 153           hreg(i,j,ia)=0.0
      hreg(1,1,1)=-3.0
      hreg(1,2,1)=3.0
      hreg(1,1,2)=-0.5
      hreg(1,2,2)=0.5
      do 900 iv=1,irun
      write(6,*) iv
	    nob=nob1
c this decomposition is valid for the simulation
c first values are generated as a normal(0,1)  atencio es pot fer d'una altra manera?????
	    call gnorm(ri,2,seed)
	    dat5(1,1)=ri(1)
	    dat5(1,2)=ri(2)
	    do 192 ik=1,nob+1000
	       do 194 j=1,2
		  if (ik.gt.1) dat5(ik,j)=dat5(ik-1,j)+var(j)
 194              x41(j,1)=dat5(ik,j) 
	       err=dat5(ik,1)-b1*dat5(ik,2)
	       ia=1
	       if(err.ge.0.0) ia=2
              CALL ZEROVEC(RI,100,10)
	      CALL GNORM(RI,2,SEED)
c agafo com a nombres aleatoris el 5 i el 10
c innovations are N(0,I2) non-correlated
	       rnn(1)=ri(1)
	       rnn(2)=ri(2)   
	       do 161 i=1,2
		  do 161 j=1,npamh
 161                 h1(i,j)=hreg(i,j,ia)
	       call multmat(h1,x41,x43,ipmax,ipmax,2,npamh,1)
	       do 171 j=1,2
 171              var(j)=x43(j,1)+rnn(j)
	       call zeromat(x41,ipmax,ipmax,1)
	       call zeromat(x43,ipmax,ipmax,1)
	       call zerovec(rnn,ipmax,ipmax)
 192        continue
	    do 193 i=1,nob
	       do 193 j=1,2
 193              dat(i,j)=dat5(i+1000,j)
	    call zeromat(dat5,1000+nmax,1000+nob,ipmax)
	    call zeromat(dat4,nmax,nob,ipmax)
	    call zeromat(dat2,nmax,nob,ipmax)
	    call zeromat(dat3,nmax,nob,ipmax)
c in dat we have the simulated set of data, dat(i,j)
c begin of the threshold search
      if (ierr.eq.1) then
	 call zerovec(c1,ipmax,ipmax)
	 call zerovec(desv1,ipmax,ipmax)
	 call reg(dat,nmax,nob,c1,desv1,0)
	 call zerovec(bcan,1000,nob)
	 upl=0.0
	 bol=0.0
	 upl=c1(1)+sig*desv1(1)
	 bol=c1(1)-sig*desv1(1)
	 step=(upl-bol)/real(10**iprec)
	 bcan(1)=bol
	 do 45 im=2,10**iprec+1
 45         bcan(im)=bcan(im-1)+step
      end if
      nob=nob-1
      do 46 i=1,nob
	 do 46 j=1,2
 46         dat2(i,j)= dat(i+1,j)-dat(i,j)              
      ip=2
      call zerovec(thr,ithmax,ithmax)
      thr(1) = -9.9d+10
      i = nreg+1
      thr(i) = 9.9d+10
      isim=0
      call zeromat(param,10000,10000,5)
      do 930 iz=1,10**iprec+1
	 isim=isim+1
	 call zerovec(err1,nmax,nob)
	 do 44 it=1, nob
	    err1(it)=dat(it,1)-bcan(iz)*dat(it,2)
 44         dat(it,3)=err1(it)
	 call zerovec(post,nmax,nob)         
	 call pcand(err1,nob,post,pl,pu,ipa)
c    S'HA DE PREPARAR PER A VARIS THRESHOLDS (MIRAR INTERESTS RATES)
	 do 600 nl=1,ipa
	    do 90 ia=1,nreg
	       thr(nreg)=post(nl)
	       icnt = 0
	       do 100 it = 2, nob
		  chk = dat(it-id,3)  
		  if(chk.lt.thr(ia)) go to 100
		  if(chk.gt.thr(ia+1)) go to 100
c------------- the observation is in the ia-th regime
		  icnt = icnt+1
		  do 52 ij=1,2
		     dat3(icnt,ij)=dat2(it,ij)
 52                  dat4(icnt,ij)=dat(it,ij)
 100           continue
	       npts(ia) = icnt
	       if(icnt.le.ip)then
	write(10,*) 'insufficient data points in the', ia,'-th regime'
		  det1(nl)=9.9d+10
		  goto 600
	       endif
	       call reg(dat4,nmax,icnt,c2,desv2,0)
	       do 200 i=ip,icnt
		  do 200 j=1,2
 200                 y1(j,i-1)=dat3(i,j)
	       do 210 i=1,icnt-ip+1
		  if (ict.eq.1) x1(1,i)=1.d+0
		  do 210 j=1,ip-1
		     do 210 k=1,2
 210                    x1(ict+k+2*(j-1),i)=dat3(i+ip-j-1,k)
		  call zeromat(xm,nmax,icnt,icnt)
		  do 220 i=1,icnt
 220                 xm(i,i)=1.0d+0
		  ior=(ip-1)*2+ict
		  call trnmat(x1,x2,ipmax,nmax,ior,icnt)
		  call multmat(x1,x2,x3,ipmax,nmax,ior,icnt,ior)
		  call matinv(x3,x4,elp1,ipmax,ior,ifail)      
		  call multmat(x4,x1,x5,ipmax,ipmax,ior,ior,icnt)
		  call multmat(x2,x5,x6,nmax,ipmax,icnt,ior,icnt)
		  call addmat(xm,x6,x7,nmax,icnt,icnt,-1)
		  call trnmat(dat4,x8,nmax,ipmax,icnt,2)
		  coef2(1,1)=1.0d+0
		  coef2(2,1)=-c2(1)
		  call multmat(dat4,coef2,x9,nmax,ipmax,icnt,2,1)
		  call multmat(x7,x9,x10,nmax,nmax,icnt,icnt,1)
		  call multmat(y1,x10,x11,ipmax,nmax,2,icnt,1)
		  call trnmat(dat4,x12,nmax,ipmax,icnt,2)
		  call multmat(x12,x10,x13,ipmax,nmax,2,icnt,1)
		  call trnmat(coef2,x14,ipmax,1,2,1)
		  call multmat(x14,x13,x15,1,ipmax,1,2,1)
		  do 230 i=1,2
 230                 h(i,1)=-x11(i,1)/x15(1,1)
		  call multmat(x2,x4,x16,nmax,ipmax,icnt,ior,ior)
		  call multmat(x14,x12,x17,1,ipmax,1,2,icnt)
		  call multmat(h,x17,x18,ipmax,1,2,1,icnt)
		  call addmat(y1,x18,x19,ipmax,2,icnt,1)
		  call multmat(x19,x16,d,ipmax,nmax,2,icnt,ior)
		  call multmat(d,x1,x30,2,ipmax,2,ior,icnt)
		  call addmat(x30,x18,x31,ipmax,2,icnt,-1)
		  call addmat(y1,x31,x32,ipmax,2,icnt,-1)
		  call trnmat(x32,x33,ipmax,nmax,2,icnt)
		  call multmat(x32,x33,x34,ipmax,nmax,2,icnt,2)
		  do 260 i=1,2
		     do 260 j=1,2
 260                    x34(i,j)=x34(i,j)/real(icnt)
		  det=0.0
		  call zeromat(wk,ipmax,ipmax,ipmax)
		  det=x34(1,1)+x34(2,2)
		  det1(nl)=det1(nl)+det
		  beta(nl,ia)=c2(1)
		  call zerovec(c2,ipmax,ipmax)
		  call zerovec(desv2,ipmax,ipmax)
		  call zeromat(er,ipmax,ipmax,ipmax)
		  call zeromat(dat3,nmax,nmax,ipmax)
		  call zeromat(dat4,nmax,nmax,ipmax)
		  call zeromat(y1,ipmax,ipmax,nmax)
		  call zeromat(x1,ipmax,ipmax,nmax)
		  call zeromat(x2,nmax,nmax,ipmax)
		  call zeromat(x3,ipmax,ipmax,ipmax)
		  call zeromat(x4,ipmax,ipmax,ipmax)
		  call zeromat(x5,ipmax,ipmax,nmax)
		  call zeromat(x6,nmax,nmax,nmax)
		  call zeromat(x9,nmax,nmax,1)
		  call zeromat(x13,ipmax,ipmax,1)
		  call zeromat(x17,1,1,nmax)
		  call zeromat(x7,nmax,nmax,nmax)
		  call zeromat(x8,ipmax,ipmax,nmax)
		  call zeromat(coef2,ipmax,ipmax,1)
		  call zeromat(x10,nmax,nmax,1)
		  call zeromat(x11,ipmax,ipmax,1)
		  call zeromat(x12,ipmax,ipmax,nmax)
		  call zeromat(x14,1,1,ipmax)
		  call zeromat(x15,1,1,1)
		  call zeromat(h,ipmax,ipmax,1)
		  call zeromat(x16,nmax,nmax,ipmax)
		  call zeromat(x18,ipmax,ipmax,nmax)
		  call zeromat(x19,ipmax,ipmax,nmax)
		  call zeromat(d,ipmax,ipmax,ipmax)
		  call zeromat(elp1,ipmax,ipmax,ipmax)
		  call zeromat(x30,ipmax,ipmax,nmax)
		  call zeromat(x31,ipmax,ipmax,nmax)
		  call zeromat(x32,ipmax,ipmax,nmax)
		  call zeromat(x33,nmax,nmax,ipmax)
		  call zeromat(x34,ipmax,ipmax,kmax)
		  call zeromat(xm,nmax,nmax,nmax)
 90            continue
 600        continue
	  detmin=det1(1)
	  imin=1
	  do 700 i=2,ipa
	     if (det1(i).lt.detmin) then
		detmin=det1(i)
		imin=i
	  endif
 700      continue
	  param(isim,1)=bcan(iz)
	  param(isim,2)=post(imin)
	  param(isim,3)=detmin
	  param(isim,4)=beta(imin,1)
	  param(isim,5)=beta(imin,2)
	  call zerovec(det1,nmax,ipa)
	  call zeromat(beta,nmax,ipa,2)
 930      continue
	  detmin=param(1,3)
	  imin=1
	  do 910 i=2,isim
	     if (param(i,3).lt.detmin) then
		detmin=param(i,3)
		imin=i
	     endif
 910      continue
	  write(10,508) (param(imin,i),i=1,5)
	  write(6,508) (param(imin,i),i=1,5)
 900   continue
c       write(10,511) sig, iprec
       call zeromat(dat,nmax,nob,ipmax)
 508   format(f10.5,2x,f10.5,2x,f10.5,2x,f10.5,2x,f10.5)
 511   format(2x,'sigmas : ',f8.3,' precision 10^-x : ',i3) 
      end       

      SUBROUTINE MULTMAT(AMAT,BMAT,CMAT,ID1MAX,ID2MAX,L1,L2,L3)
C**********************************************************************
C     PORPOSE: MATRIX MULTIPLICATION
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C            BMAT, MATRIX DIMENSION L2,L3
C     OUPUT: CMAT, MATRIX DIMENSION L1,L3
C**********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID2MAX,*),CMAT(ID1MAX,*)
      EXTERNAL ZEROMAT
      DO 99 J=1,L3
	 DO 98 K=1,L2
	    IF (BMAT(K,J).EQ.0.0) GOTO 98
	    DO 97 I=1,L1
	       CMAT(I,J)=CMAT(I,J)+AMAT(I,K)*BMAT(K,J)
   97       CONTINUE
   98    CONTINUE
   99 CONTINUE
      RETURN
      END

      SUBROUTINE MATINV(AMAT,BMAT,ELP,ID1MAX,L1,IFAIL)
C************************************************************************
C     PORPOSE: MATRIX INVERSION
C     INPUT: AMAT, MATRIX DIMENSION L1,L1
C     OUTPUT: BMAT, MATRIX DIMENSION L1,L1
C             IFAIL, MONITORING VALUE
C************************************************************************

      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID1MAX,*),ELP(ID1MAX,*)
      EXTERNAL EQMAT,ZEROMAT
C     
      CALL ZEROMAT(ELP,ID1MAX,L1,L1)
      CALL EQMAT(AMAT,ELP,ID1MAX,ID1MAX,L1,L1)
      DO 115 I=1,L1
	 BMAT(I,I)=1.0
  115 CONTINUE
      DO 99 J=1,L1
	 DO 98 I=J,L1
	    IF (ELP(I,J).NE.0.0) GOTO 11
   98    CONTINUE
	 IFAIL=1
	 RETURN
   11    CONTINUE
      DO 97 K=1,L1
C
	 PIVOT01= ELP(J,K)
	 ELP(J,K)= ELP(I,K)
	 ELP(I,K)= PIVOT01
C
	 PIV= BMAT(J,K)
	 BMAT(J,K)=BMAT(I,K)
	 BMAT(I,K)= PIV
   97 CONTINUE
C
      IF(ELP(J,J).NE.0.0) GOTO 22
C
      IFAIL=1
      RETURN
C
C
   22 CONTINUE
      PPP= 1.0/ELP(J,J)
      DO 96 K=1,L1
C
	 ELP(J,K)= ELP(J,K)*PPP
	 BMAT(J,K)= BMAT(J,K)*PPP
   96 CONTINUE
C
      DO 95 K=1,L1
C
	 IF(J.EQ.K) THEN
C
   33       CONTINUE
C
	 ELSE
	    PPP= ELP(K,J)
	    DO 94 L=1,L1
C
	       ELP(K,L)=ELP(K,L)-ELP(J,L)*PPP
	       BMAT(K,L)=BMAT(K,L)-BMAT(J,L)*PPP
   94       CONTINUE
C
	 END IF
   95 CONTINUE
   99 CONTINUE
C
      RETURN
      END

     
      SUBROUTINE ZEROMAT(AMAT,ID1MAX,L1,L2)
C**************************************************************
C     PORPOSE: CREATE A MATRIX OF ZEROS
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C     OUTPUT: AMAT, ZEROED MATRIX DIMENSION L1,L2
C**************************************************************
      
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*)
      DO 98 J=1,L2
	 DO 99 I=1,L1
	    AMAT(I,J)=0.0
  99     CONTINUE
  98  CONTINUE
      RETURN
      END

      SUBROUTINE ZEROVEC(VEC,ID1MAX,L1)
C**************************************************************
C     PORPOSE: CREATE A VECTOR OF ZEROS      
C     INPUT: VEC, VECTOR DIMENSION L1
C     OUTPUT: VEC, ZEROED VECTOR DIMENSION L1
C**************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION VEC(ID1MAX)

      DO 98 I=1,L1     
		VEC(I)=0.0
  98  CONTINUE
      RETURN
	END
   
      SUBROUTINE EQMAT(AMAT,BMAT,ID1MAX,ID2MAX,L1,L2)
C**************************************************************
C     PORPOSE: EQUALIZATION OF MATRICES 
C     INPUT: AMAT, MATRIX DIMENSION L1 L2
C     OUPUT: BMAT, MATRIX EQUAL AMAT DIMENSION L1 L2
C**************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID2MAX,*)
C
      DO 98 J=1,L2
	 DO 99 I=1,L1
	    BMAT(I,J)=AMAT(I,J)
   99    CONTINUE
   98 CONTINUE
      RETURN
      END

      SUBROUTINE EQVEC(VECA,VECB,ID1MAX,L1)
C******************************************************************
C     PORPOSE: EQUALIZATION OF VECTORS
C     INPUT: VECA, VECTOR DIMENSION L1
C     OUTPUT: VECB, VECTOR EQUAL VECA DIMENSON L1
C******************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION VECA(ID1MAX),VECB(ID1MAX)
C
      DO 99 I=1,L1
	    VECB(I)=VECA(I)
   99 CONTINUE
      RETURN
      END

      SUBROUTINE TRNMAT(AMAT,BMAT,ID1MAX,ID2MAX,L1,L2)
C********************************************************************
C     PORPOSE: TRANSPOSE A MATRIX OF DIMENSION L1,L2
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C     OUTPUT: BMAT, TRANSPOSED MATRIX DIMENSION L2,L1
C********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID2MAX,*)
C
      DO 98 J=1,L2
	 DO 99 I=1,L1
	    BMAT(J,I)=AMAT(I,J)
   99     CONTINUE
  98  CONTINUE
      RETURN
      END

      SUBROUTINE ADDMAT(AMAT,BMAT,CMAT,ID1MAX,L1,L2,IND)
C**********************************************************************
C     PORPOSE: MATRIX SUM
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C            BMAT, MATRIX DIMENSION L1,L2
C            IND,  INDICATOR VARIABLE: 1, ADD
C                                     -1, EXTRACT
C     OUPUT: CMAT, MATRIX DIMENSION L1,L2
C**********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID1MAX,*),CMAT(ID1MAX,*)
      EXTERNAL ZEROMAT
      CALL ZEROMAT(CMAT,ID1MAX,L1,L3)
      DO 2 J=1,L1
	 DO 2 K=1,L2
 2          CMAT(J,K)=AMAT(J,K)+IND*BMAT(J,K)
      RETURN
      END

      SUBROUTINE reg(dat,ID1MAX,nob,coef,desv,icf)
C**********************************************************************
C     PORPOSE: OLS ESTIMATES (NON RESTRICTED)
C**********************************************************************

      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION dat(ID1MAX,*),coef(*),dat1(100,3),dat2(3,100),dat3(3,3)
      dimension dat4(3,3),dat5(3,100),y(100,1),elp2(3,3),desv(*)
      dimension dat6(100,3)
      external multmat,matinv,trnmat,zeromat,zerovec
      s1=0.0
      s2=0.0
      s3=0.0
      call zeromat(dat1,100,100,3)
      call zeromat(dat2,3,3,100)
      call zeromat(dat3,3,3,3)
      call zeromat(dat4,3,3,3)
      call zeromat(dat5,3,3,100)
      call zerovec(coef,3,3)
      call zerovec(desv,3,3)
      call zeromat(dat6,100,100,3)
      call zeromat(y,100,100,1)
      do 100 i=1,nob
	 y(i,1)=dat(i,1)
	 if (icf.eq.1) dat1(i,1)=1.0
 100     dat1(i,1+icf)=dat(i,2)
      call trnmat(dat1,dat2,100,3,nob,1+icf)
      call multmat(dat2,dat1,dat3,3,100,1+icf,nob,1+icf)
      call matinv(dat3,dat4,elp2,3,1+icf,ifail)
      call multmat(dat4,dat2,dat5,3,3,1+icf,1+icf,nob)
      call multmat(dat5,y,coef,3,100,1+icf,nob,1)
      err=0.0
      call multmat(dat1,coef,dat6,100,3,nob,1+icf,1)
      do 110 i=1,nob
 110     err=err+(y(i,1)-dat6(i,1))**2
      xse=err/real(nob-(1+icf))
      do 120 i=1,icf+1
 120    desv(i)=sqrt(dat4(i,i)*xse)      
      end

      SUBROUTINE PCAND(X,N,CTHD,IPL,IPU,IPR)
C**************************************************************
C DEFINES CANDIDATE THRESHOLD VALUES FOR INFLATION RATES
C THRESHOLD VALUES ARE SEARCHED AMONG THE INTERPERCENTILE RANGE
C @ EQUIWIDTH INTERVALS ( # INTERVALS = # VALUES BETWEEN PERC)
C X = MATRIX OF DATA
C N = # DATA
C CTHD = ARRAY OF CANDIDATE THRESHOLD VALUES
C IPL = USER-SUPPLIED LOWER PERCENTILE
C IPU = USER-SUPPLIED UPPER PERCENTILE
C EXTERNAL SUBROUTINE = QCKSRT
C**************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 IPL,IPU
      DIMENSION X(*),CTHD(*),SARR(10000)
      EXTERNAL QCKSRT
      DO 12 I=1,N
 12      SARR(I)=X(I)
      CALL QCKSRT(N,SARR)
      IP1=NINT(IPL*N)
      AMIN=SARR(IP1)
      IP2=NINT(IPU*N)
      AMAX=SARR(IP2)
      IPR=IP2-IP1
      AI=AMAX-AMIN
      AINC=AI/REAL(IPR)
      CTHD(1)=AMIN
      DO 13 J=2,IPR
 13      CTHD(J)=CTHD(J-1)+AINC
      RETURN
      END

C#####################################################
C Quicksort routine from numerical recipes
C#####################################################
      SUBROUTINE QCKSRT(N,ARR)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (M=7,NSTACK=50,FM=7875.,FA=211.,FC=1663.
     *    ,FMI=1.2698413E-4,maxdat=10000)
      DIMENSION ISTACK(NSTACK)
      DIMENSION ARR(maxdat)
C     DOUBLE PRECISION A
      JSTACK=0
      L=1
      IR=N
      FX=0.
10    IF(IR-L.LT.M)THEN
	DO 13 J=L+1,IR
	  A=ARR(J)
	  DO 11 I=J-1,1,-1
	    IF(ARR(I).LE.A)GO TO 12
	    ARR(I+1)=ARR(I)
11        CONTINUE
	  I=0
12        ARR(I+1)=A
13      CONTINUE
	IF(JSTACK.EQ.0)RETURN
	IR=ISTACK(JSTACK)
	L=ISTACK(JSTACK-1)
	JSTACK=JSTACK-2
      ELSE
	I=L
	J=IR
	FX=MOD(FX*FA+FC,FM)
	IQ=L+(IR-L+1)*(FX*FMI)
	A=ARR(IQ)
	ARR(IQ)=ARR(L)
20      CONTINUE
21        IF(J.GT.0)THEN
	    IF(A.LT.ARR(J))THEN
	      J=J-1
	      GO TO 21
	    ENDIF
	  ENDIF
	  IF(J.LE.I)THEN
	    ARR(I)=A
	    GO TO 30
	  ENDIF
	  ARR(I)=ARR(J)
	  I=I+1
22        IF(I.LE.N)THEN
	    IF(A.GT.ARR(I))THEN
	      I=I+1
	      GO TO 22
	    ENDIF
	  ENDIF
	  IF(J.LE.I)THEN
	    ARR(J)=A
	    I=J
	    GO TO 30
	  ENDIF
	  ARR(J)=ARR(I)
	  J=J-1
	GO TO 20
30      JSTACK=JSTACK+2
	IF(JSTACK.GT.NSTACK)PAUSE 'NSTACK must be made larger.'
	IF(IR-I.GE.I-L)THEN
	  ISTACK(JSTACK)=IR
	  ISTACK(JSTACK-1)=I+1
	  IR=I-1
	ELSE
	  ISTACK(JSTACK)=I-1
	  ISTACK(JSTACK-1)=L
	  L=I+1
	ENDIF
      ENDIF
      GO TO 10
      END

       subroutine gnorm(r,nr,rs)
C       IMPLICIT REAL (A-H,O-Z)
       integer nr,rs
       real*8 r(*)
       do  1 i=1,nr
99        continue         
	  v=randu(rs)*2.-1.
	  u=randu(rs)*2.-1.
	  w=v*v+u*u
	  if(w.gt.1)goto 99
	  c=sqrt(-2.*alog(w)/w)
	  R(i)=c*v
	  r(i+1)=c*u
1      continue
       return
       end                      
		   
C**************************************************************************  
C  
      REAL FUNCTION RANDU(IX)  
C  
C UNIFORM RANDOM NUMBER GENERATOR.  
C REF: SCHRAGE, L. 1979 'A MORE PORTABLE FORTRAN RANDOM NUMBER GENERATOR'  
C      A. C. M. TRANSACTIONS ON MATHEMATICAL SOFTWARE V5 132-138.  
C  
      INTEGER A,P,IX,B15,B16,XHI,XALO,LEFTLO,FHI,K  
      DATA A/16807/,B15/32768/,B16/65536/,P/2147483647/  
      XHI=IX/B16  
      XALO=(IX-XHI*B16)*A  
      LEFTLO=XALO/B16  
      FHI=XHI*A+LEFTLO  
      K=FHI/B15  
      IX=(((XALO-LEFTLO*B16)-P)+(FHI-K*B15)*B16)+K  
      IF (IX.LT.0) IX=IX+P  
      RANDU=FLOAT(IX)*4.656612875E-10  
      RETURN  
      END  
C

